package memory.vue;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseListener;
import java.awt.event.MouseEvent;

import javax.swing.AbstractAction;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JLayeredPane;
import javax.swing.JPanel;

import memory.controleur.Controleur;
import memory.controleur.ControleurNouvellePartie;
import memory.modele.MemoryModele;
import memory.modele.Theme;

public class CarteVue implements MouseListener  {
	private JLabel labelCarte  ;
	private ImageIcon imageCarteFace ;
	private JLayeredPane jpanLigne;
	private JPanel jpanCases;
	private int positionCarte;
	private int numCartes;
	private int nbCartesRetournees = 0;
	private String nomCarte;
	
	  public CarteVue(JLayeredPane jpanLigne, JPanel jpanCases, int i, int j, int position, int numCartes) {
		  	this.positionCarte = position;
		  	this.jpanLigne = jpanLigne;
		  	this.numCartes = numCartes;
		  	
			// On dfinit un objet de type ImageIcon contenant l'image de fond
		    ImageIcon imageCarteDos = new ImageIcon("media/cartedos1.png");
		    
		    //int numCarte = Controleur.monControleurPartie.retournerNumCarte(positionCarte);
		    //System.out.println(numCarte);
		    // On test le numero du theme
		    if (MemoryModele.theme == 1) {
		    	nomCarte = Theme.theme1;
		    } else {
		    	if (MemoryModele.theme == 2) {
		    		nomCarte = Theme.theme2;
		    	}
		    }
		    String urlCarte = "media/" + nomCarte + numCartes + ".png";
		    ImageIcon imageCarteFace = new ImageIcon(urlCarte);
		    this.imageCarteFace = imageCarteFace;
		    
		    // On insert cette image dans un Jlabel
		    JLabel labelCarte = new JLabel(imageCarteDos);
		    this.labelCarte = labelCarte;
		    // On position notre label et lui affecte une taille
		    // getIconWidth et getIconHeight rcupre la taille de notre ImageIcon
		    //labelImageFond2.setSize(iconeFond2.getIconWidth(), iconeFond2.getIconHeight());
		    labelCarte.setBounds(j*120, 0, imageCarteDos.getIconWidth(), imageCarteDos.getIconHeight());
		    jpanLigne.add(labelCarte,new Integer(1));
		    
		    /*
		    System.out.println("NUM LIGNE CARTE " +jpanCases.getComponentCount());
		    System.out.println("NUM CARTE " +jpanLigne.getComponentCount());
		    */
		    //System.out.println("POS CARTE " +jpanLigne.getComponent(jpanLigne.getComponentCount()).getX());
		    // ICI ************************************ ICI ICI ICI ICI *********
		    //jpanLigne.getComponentCount();
		    
		    String nomLabel = Integer.toString(position);
		    labelCarte.setName(nomLabel);
		    labelCarte.addMouseListener(this);
		    Controleur.monControleurPartie.stockerPositionCarte(jpanCases.getComponentCount(),jpanLigne.getComponentCount()/2-1,imageCarteFace);
		    //System.out.println(positionCarte);
	  }
	  public void retournerCarteLocale(JLabel sourceJLabel) {
	  }
	  public void retournerCarte(JLabel sourceJLabel) {
		  
		  
		  //System.out.println(labelCarte.getHeight());
		  //labelCarte.setIcon(CarteVue.this.imageCarteFace);
		  //Controleur.monControleurPartie.nbCartesRetournees = Controleur.monControleurPartie.nbCartesRetournees + 1;
		  // On autorise l'action uniquement si la partie n'est pas termine
		  if (Controleur.monControleurPartie.finPartie==0) {
			  int modeJeu = Controleur.monControleurPartie.retournerModeJeu();
			  
			  if (modeJeu == 2) {
				  //int joueurEnCours = Controleur.monControleurPartie.retournerJoueurEnCours();
			  
			  }
			  int joueurEnCours = Controleur.monControleurPartie.retournerJoueurEnCours();
			  System.out.println("Joueur en cours Carte :   " + joueurEnCours);
			  if (joueurEnCours!=3){
				  
				 /*
				  if (Controleur.monControleurPartie.nbCartesRetournees==0){
					  System.out.println("PAS DE CARTE RETOURNE");
				  }*/
				  System.out.println("carte : " + Controleur.monControleurPartie.nbCartesRetournees);
				  if (Controleur.monControleurPartie.nbCartesRetournees<2){
					  labelCarte.setIcon(CarteVue.this.imageCarteFace);
					  //jpanLigne.getX();
					  Controleur.monControleurPartie.retournerCarte(this.positionCarte, sourceJLabel);
				  } else {
					  Controleur.monControleurPartie.testerCartes();
					  //Controleur.monControleurPartie.nbCartesRetournees = 0;
				  }
			  } 
		  }
	  }
	  public void mousePressed(MouseEvent e) {

	  }
	
	  public void mouseReleased(MouseEvent e) {
		 
		  JLabel sourceJLabel = (JLabel)e.getSource();
		  //System.out.println(sourceJLabel.getName());
		  //this.labelCarte.getLocation();
		  //
		  retournerCarte(sourceJLabel);
		  
		  //sourceJLabel.setIcon(Carte.this.imageCarteFace);
	  }
	
	  public void mouseEntered(MouseEvent e) {
	
	  }
	
	  public void mouseExited(MouseEvent e) {
	
	  }
	
	  public void mouseClicked(MouseEvent e) {
	  }
}
