package memory.vue;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JRadioButton;

import memory.controleur.Controleur;
import memory.controleur.ControleurNouvellePartie;
import memory.modele.MemoryModele;
import memory.modele.PlateauModele;


public class FenetreChargerNiveau extends JDialog implements ActionListener {
	  private FenetrePrincipale parentPartie;
	  private ButtonGroup bgNiveau;
	  //private JRadioButton radioDifficulte1,radioDifficulte2,radioDifficulte3,radioDifficulte4;
	  
	  public FenetreChargerNiveau(FenetrePrincipale parent) {
		    super(parent, true);
		    parentPartie = parent;
		    // Titre de la fenetre
		    setTitle("Menu"); 
		    
		    // on charge les donnes du fichier xml
		    int tabNiveaux[][] = Controleur.monControleurXML.chargerDonnees();
		    
		    this.getContentPane().setLayout(new FlowLayout());
		    
		    // Le ButtonGroup va contenir tous les JRadioButton et va permettre de n'en
		    // selectionner qu'un  la fois
		    bgNiveau = new ButtonGroup();
		    
		    // **** TRES FACILE *****************************************************
		    //Panel niveaux tres faciles
		    JPanel panTresFacile = new JPanel();
		    panTresFacile.setBackground(Color.WHITE);
		    panTresFacile.setPreferredSize(new Dimension(540,60));
  
		    // On ajoute un cadre de titre
		    panTresFacile.setBorder(BorderFactory.createTitledBorder("Difficult Trs Facile"));
		    // On cre les JRadioButton de difficul
		    // Cration du JRadioButton
		    JRadioButton radioNiveauTF = new JRadioButton("Trs Facile 1");
		    // On associe une valeur au JRadioButton
		    radioNiveauTF.setMnemonic(101);
		    radioNiveauTF.setName("facile");
		    // On definit ce JRadioButton comme selectionn par dfaut
		    radioNiveauTF.setSelected(true);
		    // On definit la couleur de fond  blanc
		    radioNiveauTF.setBackground(Color.WHITE);
		    // On ajout le JRadioButton au ButtonGroup
		    bgNiveau.add(radioNiveauTF);
		    // On ajout le JRadioButton au Panel
		    panTresFacile.add(radioNiveauTF);
		    int i;
		    for (i=2;i<=tabNiveaux[0][1];i++) {
			    // Cration du JRadioButton
			    JRadioButton radioNiveau = new JRadioButton("Trs Facile "+i);
			    // On associe une valeur au JRadioButton
			    radioNiveau.setMnemonic(100+i);
			    // On definit la couleur de fond  blanc
			    radioNiveau.setBackground(Color.WHITE);
			    // On ajout le JRadioButton au ButtonGroup
			    bgNiveau.add(radioNiveau);
			    // On ajout le JRadioButton au Panel
			    panTresFacile.add(radioNiveau);
		    }
		    
		    
		    // **** FACILE *****************************************************
		    //Panel niveaux difficult faciles
		    JPanel panFacile = new JPanel();
		    panFacile.setBackground(Color.WHITE);
		    panFacile.setPreferredSize(new Dimension(540,60));
  
		    // On ajoute un cadre de titre
		    panFacile.setBorder(BorderFactory.createTitledBorder("Difficult Facile"));
		    // On cre les JRadioButton de difficul
		    // Cration du JRadioButton
		    JRadioButton radioNiveauF = new JRadioButton("Facile 1");
		    // On associe une valeur au JRadioButton
		    radioNiveauF.setMnemonic(201);
		    // On definit la couleur de fond  blanc
		    radioNiveauF.setBackground(Color.WHITE);
		    // On ajout le JRadioButton au ButtonGroup
		    bgNiveau.add(radioNiveauF);
		    // On ajout le JRadioButton au Panel
		    panFacile.add(radioNiveauF);
		    for (i=2;i<=tabNiveaux[1][1];i++) {
			    // Cration du JRadioButton
			    JRadioButton radioNiveau = new JRadioButton("Facile "+i);
			    // On associe une valeur au JRadioButton
			    radioNiveau.setMnemonic(20+i);
			    // On definit la couleur de fond  blanc
			    radioNiveau.setBackground(Color.WHITE);
			    // On ajout le JRadioButton au ButtonGroup
			    bgNiveau.add(radioNiveau);
			    // On ajout le JRadioButton au Panel
			    panFacile.add(radioNiveau);
		    }
		    
		    // **** Normale *****************************************************
		    //Panel niveaux difficult normale
		    JPanel panNormale = new JPanel();
		    panNormale.setBackground(Color.WHITE);
		    panNormale.setPreferredSize(new Dimension(540,60));
  
		    // On ajoute un cadre de titre
		    panNormale.setBorder(BorderFactory.createTitledBorder("Difficult Normale"));
		    // On cre les JRadioButton de difficul
		    // Cration du JRadioButton
		    JRadioButton radioNiveauN = new JRadioButton("Normale 1");
		    // On associe une valeur au JRadioButton
		    radioNiveauN.setMnemonic(301);
		    // On definit la couleur de fond  blanc
		    radioNiveauN.setBackground(Color.WHITE);
		    // On ajout le JRadioButton au ButtonGroup
		    bgNiveau.add(radioNiveauN);
		    // On ajout le JRadioButton au Panel
		    panNormale.add(radioNiveauN);
		    for (i=2;i<=tabNiveaux[2][1];i++) {
			    // Cration du JRadioButton
			    JRadioButton radioNiveau = new JRadioButton("Normale "+i);
			    // On associe une valeur au JRadioButton
			    radioNiveau.setMnemonic(30+i);
			    // On definit la couleur de fond  blanc
			    radioNiveau.setBackground(Color.WHITE);
			    // On ajout le JRadioButton au ButtonGroup
			    bgNiveau.add(radioNiveau);
			    // On ajout le JRadioButton au Panel
			    panNormale.add(radioNiveau);
		    }

		    // **** Difficile *****************************************************
		    //Panel niveaux difficult Difficile
		    JPanel panDifficile = new JPanel();
		    panDifficile.setBackground(Color.WHITE);
		    panDifficile.setPreferredSize(new Dimension(540,60));
  
		    // On ajoute un cadre de titre
		    panDifficile.setBorder(BorderFactory.createTitledBorder("Difficult Difficile"));
		    // On cre les JRadioButton de difficul
		    // Cration du JRadioButton
		    JRadioButton radioNiveauD = new JRadioButton("Difficile 1");
		    // On associe une valeur au JRadioButton
		    radioNiveauD.setMnemonic(401);
		    // On definit la couleur de fond  blanc
		    radioNiveauD.setBackground(Color.WHITE);
		    // On ajout le JRadioButton au ButtonGroup
		    bgNiveau.add(radioNiveauD);
		    // On ajout le JRadioButton au Panel
		    panDifficile.add(radioNiveauD);
		    for (i=2;i<=tabNiveaux[3][1];i++) {
			    // Cration du JRadioButton
			    JRadioButton radioNiveau = new JRadioButton("Difficile "+i);
			    // On associe une valeur au JRadioButton
			    radioNiveau.setMnemonic(40+i);
			    // On definit la couleur de fond  blanc
			    radioNiveau.setBackground(Color.WHITE);
			    // On ajout le JRadioButton au ButtonGroup
			    bgNiveau.add(radioNiveau);
			    // On ajout le JRadioButton au Panel
			    panDifficile.add(radioNiveau);
		    }
		    

		    getContentPane().add(panTresFacile);
		    getContentPane().add(panFacile);
		    getContentPane().add(panNormale);
		    getContentPane().add(panDifficile);
		    
		    JPanel buttonPane = new JPanel();
		    JButton button = new JButton("OK"); 
		    buttonPane.add(button); 
		    button.addActionListener(this);
		    getContentPane().add(buttonPane, BorderLayout.SOUTH);
		    setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		    pack(); 
		    
		    setSize(550,350);
		    // On recupere la taille de la fenetre parente
		    Dimension parentSize = parent.getSize(); 
		    // On recupere les coordonnes de la fenetre parente
		    Point p = parent.getLocation(); 
		    // On recupere la taille de cette Jdialog
		    Dimension tailleJdialog = getSize();
		    // On place la Jdialog au centre de la fenetre parente
		    setLocation(p.x + (parentSize.width / 2) - (tailleJdialog.width /2), p.y + parentSize.height / 2 - (tailleJdialog.height /2));
		    setVisible(true);
	  }
	  public void actionPerformed(ActionEvent e) {
		  // On recupere la valeur du JRadio
		  int niveaux = bgNiveau.getSelection().getMnemonic();
		  //int niveau = niveau
		  String niveauxStr = String.valueOf(niveaux);
		  // On dcompose pour connaitre la difficult et le niveau
		  int difficulte = Integer.parseInt(niveauxStr.substring(0, 1));
		  int niveau = Integer.parseInt(niveauxStr.substring(1, niveauxStr.length()));
		  //String niveau2 = bgNiveau.getSelection();
		  System.out.println("Charger, niveau : "+difficulte+"n :"+niveau);
		  //MemoryModele.monPlateauModele.retournerModeJeu()
		  Controleur.monControleurNouvellePartie =  new ControleurNouvellePartie(parentPartie, difficulte, niveau, 0);
		  
		    setVisible(false); 
		    dispose(); 
	  }

}
